力扣hot100(21)搜索二维矩阵 II

方法:Z字形查找法、二分法、暴力法

面试最优 Z字形查找法:

核心思想:选对起点,一次排除一行或者一列。

找一个特殊的起点,使得每次比较之后,都能直接排除一整行或者一整列。不用遍历多余的元素。

注意不能选择左上角和右下角,因为左上角是最小的元素,如果target比他大,右边和下边的元素都可能更大,没法排除一行或者一列。右下角最大的元素同理。

可以选右上角和左下角,

右上角的元素matrix[x][y],是当前行最大的元素 ,也是当前列最小的元素。

  • 如果matrix[x][y] == target:直接找到,返回 true;
  • 如果matrix[x][y] > target:说明这一列所有元素都比target大(因为列是升序的),直接排除这一列,y--;
  • 如果matrix[x][y] < target:说明这一行所有元素都比target小(因为行是升序的),直接排除这一行,x++。
cpp 复制代码
class Solution {
public:
    bool searchMatrix(vector<vector<int>>& matrix, int target) {
        
       //Z字法:找右上角的元素 来排除一行或者一列 排出后 新的矩阵继续。
    int m =matrix.size();
    int n = matrix[0].size();
    int x=0,y = n-1;
    while(x<m && y>=0){

        if(matrix[x][y] == target){
            return true;
        }

        if(matrix[x][y]<target){
            ++x;
        }

        else{
            --y;
        }
    }
    return false;
    }
};
相关推荐
ZhengEnCi4 小时前
模型训练完整流程:从数据准备到模型上线的 10 个关键步骤(全文可跑)
后端·算法
weixin_307779135 小时前
RAG 面试陷阱——混合检索并非无条件优越:一个条件反转实验
人工智能·python·面试·职场和发展
吞下星星的少年·-·8 小时前
Div.3 CF 1131A题(排序,模拟)
算法·模拟·排序
圣保罗的大教堂8 小时前
leetcode 453. 最小操作次数使数组元素相等 中等
leetcode
aichitang20249 小时前
代数拓扑学与现代前沿视角
考研·算法·数学建模·ai·拓扑学·高考
二本咕咕-机械转码9 小时前
FreeRTOS深入解析(一)_链表与并发保护——哨兵循环链表、排序键游标、临界区与关调度
单片机·算法·链表
-银雾鸢尾-9 小时前
两数之和-C++实现
c++·算法
j7~9 小时前
【动态规划算法专题】动态规划五部曲实战:泰波那契数、三步问题、最小花费爬楼梯
c++·算法·动态规划·数据结构与算法
倍利福猎头公司官方账号9 小时前
大企业HR如何向猎头公司清晰传达AI岗位的技术需求?
人工智能·算法·机器人·求职招聘·业界资讯